import { jsx as g, jsxs as le } from "react/jsx-runtime";
import se, { useRef as f, useEffect as N, useCallback as ie, useMemo as X, useState as _, useId as ue, useReducer as de, useLayoutEffect as C } from "react";
import s from "clsx";
/*!
  @versini/ui-textarea v1.0.1
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_TEXTAREA__ || (window.__VERSINI_UI_TEXTAREA__ = {
    version: "1.0.1",
    buildTime: "09/18/2024 01:38 PM EDT",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const z = "av-text-area", fe = "av-text-area-wrapper", D = "av-text-area-helper-text", pe = "av-text-area__control--right";
function me() {
  const e = f(!1);
  return N(() => (e.current = !0, () => {
    e.current = !1;
  }), []), ie(() => e.current, []);
}
function ye(e) {
  return X(() => e.every((n) => n == null) ? () => {
  } : (n) => {
    e.forEach((t) => {
      typeof t == "function" ? t(n) : t != null && (t.current = n);
    });
  }, e);
}
const he = {
  x: 0,
  y: 0,
  width: 0,
  height: 0,
  top: 0,
  left: 0,
  bottom: 0,
  right: 0
};
function xe(e) {
  const n = me(), t = f(0), r = f(null), [o, c] = _(he), a = X(() => typeof ResizeObserver > "u" ? null : new ResizeObserver((u) => {
    const l = u[0];
    l && (cancelAnimationFrame(t.current), t.current = requestAnimationFrame(() => {
      r.current && n() && c(l.contentRect);
    }));
  }), [n]);
  return N(() => (r.current && (a == null || a.observe(r.current, e)), () => {
    a == null || a.disconnect(), t.current && cancelAnimationFrame(t.current);
  }), [a, e]), [r, o];
}
function Ae({
  value: e,
  defaultValue: n,
  finalValue: t,
  onChange: r = () => {
  },
  initialControlledDelay: o = 0
}) {
  const [c, a] = _(!1), [u, l] = _(
    n !== void 0 ? n : t
  ), p = (m) => {
    l(m), r == null || r(m);
  };
  return N(() => {
    (async () => e !== void 0 && !c && o > 0 && (await new Promise(
      (m) => setTimeout(m, o)
    ), a(!0)))();
  }, [e, o, c]), e !== void 0 ? !c && o > 0 ? ["", r, !0] : [e, r, !0] : [u, p, !1];
}
function ge(e) {
  const n = ue();
  if (!e)
    return n;
  if (typeof e == "number" || typeof e == "string")
    return `${e}${n}`;
  if (typeof e == "object") {
    const { id: t, prefix: r = "" } = e;
    return typeof t == "number" || typeof t == "string" ? `${r}${t}` : `${r}${n}`;
  }
}
const G = "SET_ANNOUNCEMENT", W = "CLEAR_ANNOUNCEMENT", Te = {
  alert: null,
  alertdialog: null,
  log: "polite",
  marquee: null,
  progressbar: null,
  status: "polite",
  timer: "assertive"
}, be = (e, n) => {
  switch (n == null ? void 0 : n.type) {
    case G:
      return {
        ...e,
        announcement: n.payload
      };
    case W:
      return {
        ...e,
        announcement: null
      };
    default:
      return e;
  }
}, ve = ({
  onAnnouncementClear: e,
  dispatch: n
}) => {
  n({
    type: W
  }), typeof e == "function" && e();
}, j = ({
  children: e,
  clearAnnouncementDelay: n,
  clearAnnouncementTimeoutRef: t,
  onAnnouncementClear: r,
  dispatch: o
}) => {
  (t == null ? void 0 : t.current) !== null && clearTimeout(t.current), e !== null && o({
    type: G,
    payload: e
  }), n && (t.current = setTimeout(
    () => ve({
      onAnnouncementClear: r,
      dispatch: o
    }),
    n
  ));
}, ke = ({
  children: e,
  announcementTimeoutRef: n,
  announcementDelay: t,
  clearAnnouncementDelay: r,
  clearAnnouncementTimeoutRef: o,
  onAnnouncementClear: c,
  dispatch: a
}) => {
  clearTimeout(n.current), t ? n.current = setTimeout(j, t, {
    children: e,
    clearAnnouncementDelay: r,
    clearAnnouncementTimeoutRef: o,
    onAnnouncementClear: c,
    dispatch: a
  }) : j({
    children: e,
    clearAnnouncementDelay: r,
    clearAnnouncementTimeoutRef: o,
    onAnnouncementClear: c,
    dispatch: a
  });
};
function _e({
  children: e,
  className: n,
  politeness: t,
  role: r = null,
  announcementDelay: o,
  clearAnnouncementDelay: c,
  onAnnouncementClear: a,
  visible: u,
  ...l
}) {
  const p = f(), m = f(), [T, v] = de(be, {
    announcement: null
  });
  let x = t;
  typeof x > "u" && (x = r ? Te[r] : "assertive"), N(() => {
    ke({
      announcementTimeoutRef: p,
      announcementDelay: o,
      children: e,
      clearAnnouncementDelay: c,
      clearAnnouncementTimeoutRef: m,
      onAnnouncementClear: a,
      dispatch: v
    });
  }, [
    e,
    o,
    c,
    a
  ]);
  const d = s(n, {
    "sr-only": !u
  });
  return /* @__PURE__ */ g(
    "div",
    {
      "aria-live": x,
      ...r && { role: r },
      className: d,
      ...l,
      children: T.announcement
    }
  );
}
const Ee = (e) => {
  let n = "";
  if (typeof e == "number" || typeof e == "string")
    n = "m-" + e;
  else {
    const t = [];
    (e == null ? void 0 : e.t) !== void 0 && t.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && t.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && t.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && t.push(`ml-${e.l}`), n = t.join(" ");
  }
  return n;
};
/*!
  @versini/ui-private v1.4.11
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_PRIVATE__ || (window.__VERSINI_UI_PRIVATE__ = {
    version: "1.4.11",
    buildTime: "09/18/2024 01:37 PM EDT",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const Re = () => "rounded-md text-base h-20 min-h-[80px] resize-none overflow-hidden px-4 py-7", Ce = ({
  mode: e
}) => s({
  "bg-surface-darker text-copy-lighter caret-copy-light": e === "dark",
  "bg-surface-lighter text-copy-dark caret-copy-dark": e === "light",
  "bg-surface-lighter text-copy-dark caret-copy-dark dark:bg-surface-darker dark:text-copy-lighter dark:caret-copy-light": e === "system",
  "bg-surface-darker text-copy-lighter caret-copy-light dark:bg-surface-lighter dark:text-copy-dark dark:caret-copy-dark": e === "alt-system"
}), Ne = ({
  focusMode: e
}) => s("focus:outline focus:outline-2 focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), Ie = ({
  noBorder: e,
  error: n
}) => s("border-2", {
  "border-border-dark": !e && !n,
  "focus:border-border-dark": !e && n,
  "border-border-error-dark": !e && n,
  "border-transparent": e
}), Se = ({
  disabled: e,
  raw: n,
  error: t,
  mode: r
}) => {
  if (n)
    return "";
  if (e)
    return s("absolute px-2 cursor-not-allowed opacity-50 font-medium");
  if (!t)
    return s("absolute px-2 cursor-text font-medium", {
      "text-copy-medium": r === "dark",
      "text-copy-dark": r === "light",
      "text-copy-dark dark:text-copy-medium": r === "system",
      "text-copy-medium dark:text-copy-dark": r === "alt-system"
    });
  if (t)
    return s("absolute px-2 cursor-text font-medium", {
      "text-copy-medium": r === "dark",
      "text-copy-error-dark": r === "light",
      "text-copy-error-dark dark:text-copy-error-light": r === "system",
      "text-copy-medium dark:text-copy-error-dark": r === "alt-system"
    });
}, Oe = ({
  error: e,
  raw: n,
  mode: t,
  disabled: r
}) => {
  if (n)
    return "";
  if (r)
    return s(
      D,
      "absolute px-2 cursor-not-allowed opacity-50 font-medium"
    );
  if (!e)
    return s(D, "absolute px-2 font-medium", {
      "text-copy-medium": t === "dark",
      "text-copy-dark": t === "light",
      "text-copy-dark dark:text-copy-medium": t === "system",
      "text-copy-medium dark:text-copy-dark": t === "alt-system"
    });
  if (e)
    return s(D, "absolute px-2 font-medium", {
      "text-copy-error-light": t === "dark",
      "text-copy-error-dark": t === "light",
      "text-copy-error-dark dark:text-copy-error-light": t === "system",
      "dark:text-copy-error-dark text-copy-error-light": t === "alt-system"
    });
}, $e = ({
  className: e,
  textAreaClassName: n,
  raw: t,
  focusMode: r,
  disabled: o,
  noBorder: c,
  error: a,
  spacing: u,
  mode: l
}) => {
  const p = t ? e : s(
    "relative flex w-full flex-col justify-center",
    fe,
    e,
    Ee(u)
  ), m = t ? s(n) : s(
    z,
    n,
    Re(),
    Ce({ mode: l }),
    Ne({ focusMode: r }),
    Ie({
      noBorder: c,
      error: a
    }),
    {
      "disabled:cursor-not-allowed disabled:opacity-50": o
    }
  ), T = t ? void 0 : "sr-only", v = Se({
    disabled: o,
    raw: t,
    error: a,
    mode: l
  }), x = Oe({
    error: a,
    raw: t,
    mode: l,
    disabled: o
  }), d = t ? void 0 : s(pe, "absolute");
  return {
    wrapper: p,
    textArea: m,
    accessibleLabel: T,
    visibleLabel: v,
    helperText: x,
    rightElement: d
  };
}, Le = ({
  scrollHeight: e,
  currentHeight: n,
  currentLabelOffset: t = 0,
  currentHelperTextOffset: r = 0
}) => {
  let a, u;
  if (e > 0 && e !== n) {
    const l = e - n, p = Math.abs(l / 24);
    a = t + -1 * Math.sign(l) * (12 * p), u = r + Math.sign(l) * (12 * p);
  }
  return {
    labelOffset: a,
    helperTextOffset: u,
    scrollHeight: e
  };
}, we = se.forwardRef(
  ({
    id: e,
    name: n,
    label: t,
    error: r = !1,
    raw: o = !1,
    className: c,
    textAreaClassName: a,
    mode: u = "system",
    focusMode: l = "system",
    value: p,
    defaultValue: m,
    disabled: T = !1,
    noBorder: v = !1,
    labelId: x,
    helperText: d = "",
    helperTextOnFocus: I = !1,
    rightElement: S,
    onChange: H,
    onFocus: M,
    onBlur: P,
    spacing: q,
    ...B
  }, J) => {
    const y = f(null), K = ye([J, y]), [Q, E] = xe(), O = f(80), F = f(-25), A = f(null), U = f(30), R = f(null), k = ge({ id: e, prefix: `${z}-` }), [Y, Z] = _(0), [ee, V] = _(
      !!(!I && d)
    ), te = `${n} error, ${d}`, b = $e({
      className: c,
      textAreaClassName: a,
      error: r,
      raw: o,
      focusMode: l,
      disabled: T,
      noBorder: v,
      spacing: q,
      mode: u
    }), [h, ne] = Ae({
      value: p,
      initialControlledDelay: 20,
      defaultValue: m,
      onChange: (i) => {
        H && H({
          target: {
            value: i
          }
        });
      }
    }), re = (i) => {
      ne(i.target.value);
    }, oe = (i) => {
      I && d && V(!0), M && M(i);
    }, ae = (i) => {
      I && d && !h && V(!1), P && P(i);
    };
    return C(() => {
      E && E.width && Z(E.width + 18 + 10);
    }, [E]), C(() => {
      o || y && y.current && h !== void 0 && (y.current.style.height = "inherit", y.current.style.height = y.current.scrollHeight + "px");
    }, [h, o]), C(() => {
      o || setTimeout(() => {
        var i;
        (i = A == null ? void 0 : A.current) == null || i.style.setProperty(
          "--av-text-area-wrapper-transition",
          h ? "none" : "all 0.2s ease-out"
        );
      }, 0);
    }, [h, o]), C(() => {
      var i, $;
      if (!o && y && y.current && h !== void 0) {
        const { labelOffset: L, helperTextOffset: w, scrollHeight: ce } = Le({
          scrollHeight: y.current.scrollHeight,
          currentHeight: O.current,
          currentLabelOffset: F.current,
          currentHelperTextOffset: U.current
        });
        L && (F.current = L, (i = A == null ? void 0 : A.current) == null || i.style.setProperty(
          "--av-text-area-label",
          `${L}px`
        )), w && (U.current = w, ($ = R == null ? void 0 : R.current) == null || $.style.setProperty(
          "--av-text-area-helper-text",
          `${w}px`
        )), O.current = ce || O.current;
      }
    }, [h, o]), /* @__PURE__ */ le("div", { className: b.wrapper, children: [
      /* @__PURE__ */ g(
        "label",
        {
          htmlFor: k,
          id: x,
          className: b.accessibleLabel,
          children: t
        }
      ),
      /* @__PURE__ */ g(
        "textarea",
        {
          ref: K,
          id: k,
          name: n,
          disabled: T,
          placeholder: o ? void 0 : " ",
          className: b.textArea,
          rows: 1,
          ...d && { "aria-describedby": `${k}-helper` },
          ...r && { "aria-invalid": "true" },
          ...S && !o && { style: { paddingRight: Y } },
          value: h,
          onChange: re,
          onFocus: oe,
          onBlur: ae,
          ...B
        }
      ),
      !o && /* @__PURE__ */ g(
        "label",
        {
          ref: A,
          "aria-hidden": !0,
          htmlFor: k,
          className: b.visibleLabel,
          children: t
        }
      ),
      ee && /* @__PURE__ */ g(
        "div",
        {
          ref: R,
          id: `${k}-helper`,
          className: b.helperText,
          children: d
        }
      ),
      S && /* @__PURE__ */ g(
        "div",
        {
          ref: Q,
          className: b.rightElement,
          children: S
        }
      ),
      r && d && /* @__PURE__ */ g(_e, { politeness: "polite", clearAnnouncementDelay: 500, children: te })
    ] });
  }
);
we.displayName = "TextArea";
export {
  z as TEXT_AREA_CLASSNAME,
  pe as TEXT_AREA_CONTROL_RIGHT_CLASSNAME,
  D as TEXT_AREA_HELPER_TEXT_CLASSNAME,
  fe as TEXT_AREA_WRAPPER_CLASSNAME,
  we as TextArea
};
